diff --git a/lib/eal/include/rte_seqcount.h b/lib/eal/include/rte_seqcount.h
index ff62708e1b7b..6390a5a72f7c 100644
--- a/lib/eal/include/rte_seqcount.h
+++ b/lib/eal/include/rte_seqcount.h
@@ -40,15 +40,11 @@ typedef struct {
 #define RTE_SEQCOUNT_INITIALIZER { .sn = 0 }
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice.
- *
  * Initialize the sequence counter.
  *
  * @param seqcount
  *   A pointer to the sequence counter.
  */
-__rte_experimental
 static inline void
 rte_seqcount_init(rte_seqcount_t *seqcount)
 {
@@ -56,9 +52,6 @@ rte_seqcount_init(rte_seqcount_t *seqcount)
 }
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice.
- *
  * Begin a read-side critical section.
  *
  * A call to this function marks the beginning of a read-side critical
@@ -100,8 +93,6 @@ rte_seqcount_init(rte_seqcount_t *seqcount)
  *
  * @see rte_seqcount_read_retry()
  */
-
-__rte_experimental
 static inline uint32_t
 rte_seqcount_read_begin(const rte_seqcount_t *seqcount)
 {
@@ -113,9 +104,6 @@ rte_seqcount_read_begin(const rte_seqcount_t *seqcount)
 }
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice.
- *
  * End a read-side critical section.
  *
  * A call to this function marks the end of a read-side critical
@@ -145,8 +133,6 @@ rte_seqcount_read_begin(const rte_seqcount_t *seqcount)
  *
  * @see rte_seqcount_read_begin()
  */
-
-__rte_experimental
 static inline bool
 rte_seqcount_read_retry(const rte_seqcount_t *seqcount, uint32_t begin_sn)
 {
@@ -171,9 +157,6 @@ rte_seqcount_read_retry(const rte_seqcount_t *seqcount, uint32_t begin_sn)
 }
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice.
- *
  * Begin a write-side critical section.
  *
  * A call to this function marks the beginning of a write-side
@@ -195,8 +178,6 @@ rte_seqcount_read_retry(const rte_seqcount_t *seqcount, uint32_t begin_sn)
  *
  * @see rte_seqcount_write_end()
  */
-
-__rte_experimental
 static inline void
 rte_seqcount_write_begin(rte_seqcount_t *seqcount)
 {
@@ -213,9 +194,6 @@ rte_seqcount_write_begin(rte_seqcount_t *seqcount)
 }
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice.
- *
  * End a write-side critical section.
  *
  * A call to this function marks the end of the write-side critical
@@ -227,7 +205,6 @@ rte_seqcount_write_begin(rte_seqcount_t *seqcount)
  *
  * @see rte_seqcount_write_begin()
  */
-__rte_experimental
 static inline void
 rte_seqcount_write_end(rte_seqcount_t *seqcount)
 {
diff --git a/lib/eal/include/rte_seqlock.h b/lib/eal/include/rte_seqlock.h
index fcbb9c586668..589c98188529 100644
--- a/lib/eal/include/rte_seqlock.h
+++ b/lib/eal/include/rte_seqlock.h
@@ -114,9 +114,6 @@ typedef struct {
 	}
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice.
- *
  * Initialize the seqlock.
  *
  * This function initializes the seqlock, and leaves the writer-side
@@ -125,7 +122,6 @@ typedef struct {
  * @param seqlock
  *   A pointer to the seqlock.
  */
-__rte_experimental
 static inline void
 rte_seqlock_init(rte_seqlock_t *seqlock)
 {
@@ -134,9 +130,6 @@ rte_seqlock_init(rte_seqlock_t *seqlock)
 }
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice.
- *
  * Begin a read-side critical section.
  *
  * See rte_seqcount_read_retry() for details.
@@ -150,8 +143,6 @@ rte_seqlock_init(rte_seqlock_t *seqlock)
  * @see rte_seqlock_read_retry()
  * @see rte_seqcount_read_retry()
  */
-
-__rte_experimental
 static inline uint32_t
 rte_seqlock_read_begin(const rte_seqlock_t *seqlock)
 {
@@ -159,9 +150,6 @@ rte_seqlock_read_begin(const rte_seqlock_t *seqlock)
 }
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice.
- *
  * End a read-side critical section.
  *
  * See rte_seqcount_read_retry() for details.
@@ -177,7 +165,6 @@ rte_seqlock_read_begin(const rte_seqlock_t *seqlock)
  *
  * @see rte_seqlock_read_begin()
  */
-__rte_experimental
 static inline bool
 rte_seqlock_read_retry(const rte_seqlock_t *seqlock, uint32_t begin_sn)
 {
@@ -185,9 +172,6 @@ rte_seqlock_read_retry(const rte_seqlock_t *seqlock, uint32_t begin_sn)
 }
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice.
- *
  * Begin a write-side critical section.
  *
  * A call to this function acquires the write lock associated @p
@@ -212,7 +196,6 @@ rte_seqlock_read_retry(const rte_seqlock_t *seqlock, uint32_t begin_sn)
  *
  * @see rte_seqlock_write_unlock()
  */
-__rte_experimental
 static inline void
 rte_seqlock_write_lock(rte_seqlock_t *seqlock)
 	__rte_exclusive_lock_function(&seqlock->lock)
@@ -224,9 +207,6 @@ rte_seqlock_write_lock(rte_seqlock_t *seqlock)
 }
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice.
- *
  * End a write-side critical section.
  *
  * A call to this function marks the end of the write-side critical
@@ -238,7 +218,6 @@ rte_seqlock_write_lock(rte_seqlock_t *seqlock)
  *
  * @see rte_seqlock_write_lock()
  */
-__rte_experimental
 static inline void
 rte_seqlock_write_unlock(rte_seqlock_t *seqlock)
 	__rte_unlock_function(&seqlock->lock)