diff --git a/lib/eal/include/rte_bitmap.h b/lib/eal/include/rte_bitmap.h
index 46a822768d50..ec819595624c 100644
--- a/lib/eal/include/rte_bitmap.h
+++ b/lib/eal/include/rte_bitmap.h
@@ -203,9 +203,6 @@ rte_bitmap_init(uint32_t n_bits, uint8_t *mem, uint32_t mem_size)
 }
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice.
- *
  * Bitmap clear slab overhead bits.
  *
  * @param slabs
@@ -215,7 +212,6 @@ rte_bitmap_init(uint32_t n_bits, uint8_t *mem, uint32_t mem_size)
  * @param pos
  *   The start bit position in the slabs to be cleared.
  */
-__rte_experimental
 static inline void
 __rte_bitmap_clear_slab_overhead_bits(uint64_t *slabs, uint32_t slab_size,
 				      uint32_t pos)
@@ -235,9 +231,6 @@ __rte_bitmap_clear_slab_overhead_bits(uint64_t *slabs, uint32_t slab_size,
 }
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice.
- *
  * Bitmap initialization with all bits set
  *
  * @param n_bits
@@ -249,7 +242,6 @@ __rte_bitmap_clear_slab_overhead_bits(uint64_t *slabs, uint32_t slab_size,
  * @return
  *   Handle to bitmap instance.
  */
-__rte_experimental
 static inline struct rte_bitmap *
 rte_bitmap_init_with_all_set(uint32_t n_bits, uint8_t *mem, uint32_t mem_size)
 {
diff --git a/lib/eal/include/rte_bitops.h b/lib/eal/include/rte_bitops.h
index f50dbe43880c..41b1878841fc 100644
--- a/lib/eal/include/rte_bitops.h
+++ b/lib/eal/include/rte_bitops.h
@@ -40,9 +40,6 @@ extern "C" {
 /*------------------------ 32-bit relaxed operations ------------------------*/
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change, or be removed, without prior notice
- *
  * Get the target bit from a 32-bit value without memory ordering.
  *
  * @param nr
@@ -52,7 +49,6 @@ extern "C" {
  * @return
  *   The target bit.
  */
-__rte_experimental
 static inline uint32_t
 rte_bit_relaxed_get32(unsigned int nr, volatile uint32_t *addr)
 {
@@ -63,9 +59,6 @@ rte_bit_relaxed_get32(unsigned int nr, volatile uint32_t *addr)
 }
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change, or be removed, without prior notice
- *
  * Set the target bit in a 32-bit value to 1 without memory ordering.
  *
  * @param nr
@@ -73,7 +66,6 @@ rte_bit_relaxed_get32(unsigned int nr, volatile uint32_t *addr)
  * @param addr
  *   The address holding the bit.
  */
-__rte_experimental
 static inline void
 rte_bit_relaxed_set32(unsigned int nr, volatile uint32_t *addr)
 {
@@ -84,9 +76,6 @@ rte_bit_relaxed_set32(unsigned int nr, volatile uint32_t *addr)
 }
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change, or be removed, without prior notice
- *
  * Clear the target bit in a 32-bit value to 0 without memory ordering.
  *
  * @param nr
@@ -94,7 +83,6 @@ rte_bit_relaxed_set32(unsigned int nr, volatile uint32_t *addr)
  * @param addr
  *   The address holding the bit.
  */
-__rte_experimental
 static inline void
 rte_bit_relaxed_clear32(unsigned int nr, volatile uint32_t *addr)
 {
@@ -105,9 +93,6 @@ rte_bit_relaxed_clear32(unsigned int nr, volatile uint32_t *addr)
 }
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change, or be removed, without prior notice
- *
  * Return the original bit from a 32-bit value, then set it to 1 without
  * memory ordering.
  *
@@ -118,7 +103,6 @@ rte_bit_relaxed_clear32(unsigned int nr, volatile uint32_t *addr)
  * @return
  *   The original bit.
  */
-__rte_experimental
 static inline uint32_t
 rte_bit_relaxed_test_and_set32(unsigned int nr, volatile uint32_t *addr)
 {
@@ -131,9 +115,6 @@ rte_bit_relaxed_test_and_set32(unsigned int nr, volatile uint32_t *addr)
 }
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change, or be removed, without prior notice
- *
  * Return the original bit from a 32-bit value, then clear it to 0 without
  * memory ordering.
  *
@@ -144,7 +125,6 @@ rte_bit_relaxed_test_and_set32(unsigned int nr, volatile uint32_t *addr)
  * @return
  *   The original bit.
  */
-__rte_experimental
 static inline uint32_t
 rte_bit_relaxed_test_and_clear32(unsigned int nr, volatile uint32_t *addr)
 {
@@ -159,9 +139,6 @@ rte_bit_relaxed_test_and_clear32(unsigned int nr, volatile uint32_t *addr)
 /*------------------------ 64-bit relaxed operations ------------------------*/
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change, or be removed, without prior notice
- *
  * Get the target bit from a 64-bit value without memory ordering.
  *
  * @param nr
@@ -171,7 +148,6 @@ rte_bit_relaxed_test_and_clear32(unsigned int nr, volatile uint32_t *addr)
  * @return
  *   The target bit.
  */
-__rte_experimental
 static inline uint64_t
 rte_bit_relaxed_get64(unsigned int nr, volatile uint64_t *addr)
 {
@@ -182,9 +158,6 @@ rte_bit_relaxed_get64(unsigned int nr, volatile uint64_t *addr)
 }
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change, or be removed, without prior notice
- *
  * Set the target bit in a 64-bit value to 1 without memory ordering.
  *
  * @param nr
@@ -192,7 +165,6 @@ rte_bit_relaxed_get64(unsigned int nr, volatile uint64_t *addr)
  * @param addr
  *   The address holding the bit.
  */
-__rte_experimental
 static inline void
 rte_bit_relaxed_set64(unsigned int nr, volatile uint64_t *addr)
 {
@@ -203,9 +175,6 @@ rte_bit_relaxed_set64(unsigned int nr, volatile uint64_t *addr)
 }
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change, or be removed, without prior notice
- *
  * Clear the target bit in a 64-bit value to 0 without memory ordering.
  *
  * @param nr
@@ -213,7 +182,6 @@ rte_bit_relaxed_set64(unsigned int nr, volatile uint64_t *addr)
  * @param addr
  *   The address holding the bit.
  */
-__rte_experimental
 static inline void
 rte_bit_relaxed_clear64(unsigned int nr, volatile uint64_t *addr)
 {
@@ -224,9 +192,6 @@ rte_bit_relaxed_clear64(unsigned int nr, volatile uint64_t *addr)
 }
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change, or be removed, without prior notice
- *
  * Return the original bit from a 64-bit value, then set it to 1 without
  * memory ordering.
  *
@@ -237,7 +202,6 @@ rte_bit_relaxed_clear64(unsigned int nr, volatile uint64_t *addr)
  * @return
  *   The original bit.
  */
-__rte_experimental
 static inline uint64_t
 rte_bit_relaxed_test_and_set64(unsigned int nr, volatile uint64_t *addr)
 {
@@ -250,9 +214,6 @@ rte_bit_relaxed_test_and_set64(unsigned int nr, volatile uint64_t *addr)
 }
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change, or be removed, without prior notice
- *
  * Return the original bit from a 64-bit value, then clear it to 0 without
  * memory ordering.
  *
@@ -263,7 +224,6 @@ rte_bit_relaxed_test_and_set64(unsigned int nr, volatile uint64_t *addr)
  * @return
  *   The original bit.
  */
-__rte_experimental
 static inline uint64_t
 rte_bit_relaxed_test_and_clear64(unsigned int nr, volatile uint64_t *addr)
 {